Bug 1001127 - Review Request: yaml-cpp03 - A YAML parser and emitter for C++
Review Request: yaml-cpp03 - A YAML parser and emitter for C++
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Peng Wu
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 952218
  Show dependency treegraph
 
Reported: 2013-08-26 10:26 EDT by Richard Shaw
Modified: 2014-05-20 14:36 EDT (History)
5 users (show)

See Also:
Fixed In Version: yaml-cpp03-0.3.0-4.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-15 15:33:01 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
pwu: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Richard Shaw 2013-08-26 10:26:38 EDT
Spec URL: http://hobbes1069.fedorapeople.org//yaml-cpp3.spec
SRPM URL: http://hobbes1069.fedorapeople.org//yaml-cpp3-0.3.0-1.fc18.src.rpm

Description:
yaml-cpp is a YAML parser and emitter in C++ written around the YAML 1.2 spec.

This is a compatibility package for version 3.
Comment 1 Richard Shaw 2013-08-26 10:26:48 EDT
This package built on koji:  http://koji.fedoraproject.org/koji/taskinfo?taskID=5854797
Comment 2 Christopher Meng 2013-08-26 11:57:54 EDT
Can we name it compat-yaml-cpp?
Comment 3 Richard Shaw 2013-08-26 12:06:23 EDT
I'm not particular but the guidelines seem to suggest this method.

I found this discussion from 2009 that seems to indicate that appending the soversion to the name is the preferred method:

https://lists.fedoraproject.org/pipermail/packaging/2009-August/006431.html
Comment 4 Solomon Peachy 2013-08-26 17:03:10 EDT
Shouldn't this package have a "Obsoletes: yaml-cpp < 0.5.0" tag (or equivalent)?
Comment 5 Richard Shaw 2013-08-26 17:10:17 EDT
I'm not sure what that would accomplish, but no, this is designed to be parallel installable, which is why I hand moved the files that would conflict with a new 0.5.0 release.
Comment 6 Solomon Peachy 2013-08-26 17:25:47 EDT
Well, just going on my testing use case here; I tried to install it on my F19 system and rpm complained about it conflicting with the currently-installed yaml-cpp-0.3 package.  Without the obsoletes tag, it won't automatically replace the old package.
Comment 7 Solomon Peachy 2013-08-26 17:28:41 EDT
This is what I mean:

rpm -Uvh yaml-cpp3-* --test
Preparing...                          ################################# [100%]
        file /usr/lib64/libyaml-cpp.so.0.3.0 from install of yaml-cpp3-0.3.0-1.fc19.x86_64 conflicts with file from package yaml-cpp-0.3.0-3.fc19.x86_64
Comment 8 Richard Shaw 2013-08-26 17:29:27 EDT
That's expected as the current package hasn't been updated to 0.5.X yet so there's a direct soname conflict with the library. The update (for both packages) would have to be put in the same bodhi update probably to mitigate this.
Comment 9 Michael Schwendt 2013-08-26 18:19:35 EDT
It would be more correct to rename the old yaml-cpp to yaml-cpp3 with a proper Obsoletes tag. That also aids depsolvers.

Currently, what would happen is that the depsolver would try to update yaml-cpp from 0.3.0 to e.g. 0.5.0 and find that this would break existing deps (if any). The depsolver probably will search further to see whether anything else still provides the needed 0.3.0 lib, but: somebody, who only needs the 0.3.0 lib, would only need the renamed package, *not* also the upgrade. So, replacing the old package via Obsoletes would be the way to go:

  https://fedoraproject.org/wiki/Packaging:Guidelines#Renaming.2FReplacing_Existing_Packages


> compat-yaml-cpp

Originally, the compat- prefix has been the naming scheme only for run-time packages with no corresponding -devel subpackage. You could install the compat lib package, but you could not use it in BuildRequires because of a missing -devel package.
Comment 10 Richard Shaw 2013-08-26 21:59:13 EDT
Ok, I didn't quite catch the obsoletes tag the first time, I was thinking "<=", but it's only "<".
Comment 11 Richard Shaw 2013-09-04 14:16:30 EDT
Ok, updated per guidelines AFAICT..

Spec URL: http://hobbes1069.fedorapeople.org/yaml-cpp3.spec
SRPM URL: http://hobbes1069.fedorapeople.org/yaml-cpp3-0.3.0-2.fc18.src.rpm

Per the guidelines I did it as follows:
Provides:       yaml-cpp = %{version}-%{release}
Obsoletes:      yaml-cpp <= 0.3.0-5
Comment 12 Solomon Peachy 2013-09-04 14:45:35 EDT
I believe you need to perform the same magic to the yaml-cpp3-devel subpackage:

Provides:       yaml-cpp-devel = %{version}-%{release}
Obsoletes:      yaml-cpp-devel <= 0.3.0-5
Comment 13 Michael Schwendt 2013-09-04 14:47:19 EDT
The guidelines suggest "less than" not "less than or equal to". The latter is more difficult to do because of the dist tag.

In Fedora, because of the dist tag, no package would ever match 0.3.0-5.

Latest build in koji is  yaml-cpp-0.3.0-4.fc20  so:

  Obsoletes: yaml-cpp < 0.3.0-5

No immediate need to change the spec already, however.
Comment 14 Richard Shaw 2013-09-04 14:49:51 EDT
Thanks for the clarification Michael!

I've got it updated on my end, but it doesn't appear to be a showstopper for the review.
Comment 15 Richard Shaw 2013-09-27 16:14:54 EDT
Spec URL: http://hobbes1069.fedorapeople.org/yaml-cpp3.spec
SRPM URL: http://hobbes1069.fedorapeople.org/yaml-cpp3-0.3.0-3.fc18.src.rpm

Solomon,

Are you still up for the review?
Comment 16 Solomon Peachy 2013-10-06 21:21:49 EDT
Sure thing; give me a day or two. (Just got back from two weeks on the road, largely out of touch)
Comment 17 Solomon Peachy 2013-10-16 09:23:53 EDT
Sorry about the delay in following up; one nitpick is that IMO the -devel package's description should also include someting similar to the parent's "This is a compatibility package for version 3" verbage.

The package passes my functional tests (ie pre-existing yaml-cpp-0.3.0 stuff continues to work and compiling new stuff against yaml-cpp3 appears to work too).

I'm setting up the mock environment to do a formal package review now.
Comment 18 Solomon Peachy 2013-10-16 09:28:19 EDT
Ahem, looks like there's a typo.  Let's fix this.

Spec URL: http://hobbes1069.fedorapeople.org/yaml-cpp3.spec
SRPM URL: http://hobbes1069.fedorapeople.org/yaml-cpp3-0.3.0-3.fc19.src.rpm
Comment 19 Solomon Peachy 2013-10-16 09:58:06 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 92 files have unknown license. Detailed output of
     licensecheck in /tmp/1001127-yaml-cpp3/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: yaml-cpp3-0.3.0-3.fc19.x86_64.rpm
          yaml-cpp3-devel-0.3.0-3.fc19.x86_64.rpm
          yaml-cpp3-0.3.0-3.fc19.src.rpm
yaml-cpp3.x86_64: W: spelling-error %description -l en_US cpp -> cop, pp, cps
yaml-cpp3.x86_64: W: self-obsoletion yaml-cpp < 0.3.0-5 obsoletes yaml-cpp = 0.3.0-3.fc19
yaml-cpp3-devel.x86_64: W: self-obsoletion yaml-cpp-devel < 0.3.0-5 obsoletes yaml-cpp-devel = 0.3.0-3.fc19
yaml-cpp3-devel.x86_64: W: no-documentation
yaml-cpp3.src: W: spelling-error %description -l en_US cpp -> cop, pp, cps
3 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint yaml-cpp3 yaml-cpp3-devel
yaml-cpp3.x86_64: W: spelling-error %description -l en_US cpp -> cop, pp, cps
yaml-cpp3.x86_64: W: self-obsoletion yaml-cpp < 0.3.0-5 obsoletes yaml-cpp = 0.3.0-3.fc19
yaml-cpp3.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libyaml-cpp.so.0.3.0 /lib64/libm.so.6
yaml-cpp3-devel.x86_64: W: self-obsoletion yaml-cpp-devel < 0.3.0-5 obsoletes yaml-cpp-devel = 0.3.0-3.fc19
yaml-cpp3-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 5 warnings.
# echo 'rpmlint-done:'



Requires
--------
yaml-cpp3 (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)

yaml-cpp3-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    boost-devel
    libyaml-cpp.so.0.3()(64bit)
    pkgconfig
    yaml-cpp3(x86-64)



Provides
--------
yaml-cpp3:
    libyaml-cpp.so.0.3()(64bit)
    yaml-cpp
    yaml-cpp3
    yaml-cpp3(x86-64)

yaml-cpp3-devel:
    pkgconfig(yaml-cpp3)
    yaml-cpp-devel
    yaml-cpp3-devel
    yaml-cpp3-devel(x86-64)

Source checksums
----------------
http://yaml-cpp.googlecode.com/files/yaml-cpp-0.3.0.tar.gz :
  CHECKSUM(SHA256) this package     : 2cd038b5a1583b6745e949e196fba525f6d0d5fd340566585fde24fc7e117b82
  CHECKSUM(SHA256) upstream package : 2cd038b5a1583b6745e949e196fba525f6d0d5fd340566585fde24fc7e117b82


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1001127
Buildroot used: fedora-19-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 20 Solomon Peachy 2013-10-16 10:07:30 EDT
While the package appears be fine, I can't do anything further here, since I'm not an actual packager in Fedora-land so I can't formally say the package passes muster.  (I really should get myself sponsored one of these days...)

Anyway.
Comment 21 Jens Petersen 2013-10-17 04:19:21 EDT
Would yaml-cpp03 be a better name?  dunno
Comment 22 Peng Wu 2013-10-24 22:09:48 EDT
Any news from the OpenColorIO upstream, which uses yaml-cpp 0.3?
Comment 23 Richard Shaw 2013-10-24 23:15:45 EDT
It was discussed at the time 0.5 was released and the decision was to stick with the 0.3 API since it was going to stay supported. That was probably 2 years ago at this point. 

Someone else had the same issue and opened a ticket for it on github so I'll reference it here:
https://github.com/imageworks/OpenColorIO/issues/318
Comment 24 Peng Wu 2013-10-29 01:07:53 EDT
Do you prefer to start the review now, or wait the upstream reply for another week?
Comment 25 Richard Shaw 2013-10-29 13:50:18 EDT
I have not gotten a response from upstream. As far as I know, yaml-cpp upstream is still supporting the 0.3 API, I think we should move forward with the review. Once complete, I will update the current yaml-cpp to 0.5 and most packages will probably work fine with it. The ones that truly require 0.3 will need to be patched slightly but it should not be difficult.
Comment 26 Peng Wu 2013-10-30 00:46:37 EDT
I also think yaml-cpp03 is a better name, See:
https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Multiple_packages_with_the_same_base_name

Could you also upload a draft version of yaml-cpp 0.5 package, then I can test the installation of both packages manually.
Comment 27 Richard Shaw 2013-10-30 12:14:16 EDT
I'm not too particular on the name but the 03 does look funny...

Here's the 0.5.1 source RPM:
https://dl.dropboxusercontent.com/u/34775202/yaml-cpp-0.5.1-1.fc19.src.rpm
Comment 28 Parag AN(पराग) 2013-10-30 12:34:50 EDT
I see some packages similar names
$ sudo yum list | grep "^[a-z]*0[0-9]"
Comment 30 Peng Wu 2013-10-31 03:22:23 EDT
After checked with fedora-review and manually installation of both packages.

Here are some suggestions:

Please use "version 0.3" in the description of the spec file:
"This is a compatibility package for version 3."

All other looks good.

APPROVED.
Comment 31 Richard Shaw 2013-10-31 09:33:27 EDT
oops! I'll fix that. Thanks for the review!
Comment 32 Richard Shaw 2013-10-31 09:44:28 EDT
New Package SCM Request
=======================
Package Name: yaml-cpp03
Short Description: A YAML parser and emitter for C++
Owners: hobbes1069
Branches: f19 f20
InitialCC:
Comment 33 Gwyn Ciesla 2013-10-31 09:50:47 EDT
Git done (by process-git-requests).
Comment 34 Richard Shaw 2013-10-31 12:15:28 EDT
yaml-cpp03 is now built for f19, 20, and rawhide and a buildroot complete for f19 & 20. You can now try to build your package against it (don't forget to update your BR to yaml-cpp03-devel).
Comment 35 Fedora Update System 2013-10-31 12:35:32 EDT
yaml-cpp03-0.3.0-4.fc19,OpenColorIO-1.0.8-6.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/yaml-cpp03-0.3.0-4.fc19,OpenColorIO-1.0.8-6.fc19
Comment 36 Fedora Update System 2013-10-31 12:35:42 EDT
yaml-cpp03-0.3.0-4.fc20,OpenColorIO-1.0.8-6.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/yaml-cpp03-0.3.0-4.fc20,OpenColorIO-1.0.8-6.fc20
Comment 37 Fedora Update System 2013-10-31 23:54:21 EDT
yaml-cpp03-0.3.0-4.fc19, OpenColorIO-1.0.8-6.fc19 has been pushed to the Fedora 19 testing repository.
Comment 38 Fedora Update System 2013-11-15 15:33:01 EST
yaml-cpp03-0.3.0-4.fc19, OpenColorIO-1.0.8-6.fc19 has been pushed to the Fedora 19 stable repository.
Comment 39 Fedora Update System 2013-11-16 02:00:32 EST
yaml-cpp03-0.3.0-4.fc20, OpenColorIO-1.0.8-6.fc20 has been pushed to the Fedora 20 stable repository.
Comment 40 Richard Shaw 2014-05-20 14:22:59 EDT
Package Change Request
======================
Package Name: yaml-cpp03
New Branches: epel7
Owners: hobbes1069
InitialCC:
Comment 41 Gwyn Ciesla 2014-05-20 14:36:00 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.